routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::middleware(['auth'])->group(function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Route::resource('department', DepartmentController::class);
    Route::resource('jenis-surat', JenisSuratController::class);
    Route::resource('user', UserController::class);
    Route::resource('nomor-surat', NomorSuratController::class);
});

app/Models/Department.php
<?php

/**
 * Created by Reliese Model.
 */

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\Eloquent\Model;

/**
 * Class Department
 * 
 * @property int $id
 * @property string $kode_department
 * @property string $nama_department
 * @property Carbon|null $created_at
 * @property Carbon|null $updated_at
 * 
 * @property Collection|User[] $users
 *
 * @package App\Models
 */
class Department extends Model
{
	protected $table = 'departments';

	protected $fillable = [
		'kode_department',
		'nama_department'
	];

	public function users()
	{
		return $this->hasMany(User::class);
	}
}

app/Http/Controllers/DepartmentController.php
<?php

namespace App\Http\Controllers;

use DB;
use App\Models\Department;
use Illuminate\Http\Request;

class DepartmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $listDepartment = Department::get();

        return view('pages.department.index', compact('listDepartment'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.department.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'kode_department' => 'required',
            'nama_department' => 'required',
        ]);

        DB::beginTransaction();
        try {

            Department::create([
                'kode_department' => $request->kode_department,
                'nama_department' => $request->nama_department,
            ]);
            
            DB::commit();
            return redirect(route('department.index'))->with('info', 'berhasil di proses');
        } catch (\Throwable $th) {
            //throw $th;
            DB::rollback();
            return redirect()->back()->withInput()->withErrors('gagal input data');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $idDepartment = \Crypt::decrypt($id);
        $department = Department::findorfail($idDepartment);
        
        return view('pages.department.edit', compact('department'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'kode_department' => 'required',
            'nama_department' => 'required',
        ]);

        DB::beginTransaction();
        try {
            $idDepartment = \Crypt::decrypt($id);
            $department = Department::findorfail($idDepartment);
            $department->kode_department = $request->kode_department;
            $department->nama_department = $request->nama_department;
            $department->save();
            
            DB::commit();
            return redirect(route('department.index'))->with('info', 'berhasil di update');
        } catch (\Throwable $th) {
            //throw $th;
            DB::rollback();
            return redirect()->back()->withInput()->withErrors('gagal input data');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $idDepartment = \Crypt::decrypt($id);
        $department = Department::findorfail($idDepartment);
        $department->delete();

        return redirect(route('department.index'))->with('info', 'berhasil di delete');
    }
}

resources/views/pages/department/create.blade.php
@extends('layouts.app')

@section('title', 'Create Department')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Create Department') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('department.store') }}">
                        @csrf

                        <div class="form-group row">
                            <label for="kode_department" class="col-md-4 col-form-label text-md-right">{{ __('Kode Department') }}</label>

                            <div class="col-md-6">
                                <input id="kode_department" type="text" class="form-control @error('kode_department') is-invalid @enderror" name="kode_department" value="{{ old('kode_department') }}" required autocomplete="kode_department" autofocus>

                                @error('kode_department')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="nama_department" class="col-md-4 col-form-label text-md-right">{{ __('Nama Department') }}</label>

                            <div class="col-md-6">
                                <input id="nama_department" type="text" class="form-control @error('nama_department') is-invalid @enderror" name="nama_department" value="{{ old('nama_department') }}" required autocomplete="nama_department" autofocus>

                                @error('nama_department')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>


                        <div class="form-group row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Save') }}
                                </button>
                                <a href="{{ route('department.index') }}">
                                <button type="button" class="btn btn-danger">
                                    {{ __('Cancel') }}
                                </button>
                                </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    
@endsection

resources/views/pages/department/edit.blade.php
@extends('layouts.app')

@section('title', 'Edit Department')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Edit Department') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('department.update', \Crypt::encrypt($department->id)) }}">
                        @csrf
                        <input type="hidden" name="_method" value="PUT">

                        <div class="form-group row">
                            <label for="kode_department" class="col-md-4 col-form-label text-md-right">{{ __('Kode Department') }}</label>

                            <div class="col-md-6">
                                <input id="kode_department" type="text" class="form-control @error('kode_department') is-invalid @enderror" name="kode_department" value="{{ old('kode_department', $department->kode_department) }}" required autocomplete="kode_department" autofocus>

                                @error('kode_department')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="nama_department" class="col-md-4 col-form-label text-md-right">{{ __('Nama Department') }}</label>

                            <div class="col-md-6">
                                <input id="nama_department" type="text" class="form-control @error('nama_department') is-invalid @enderror" name="nama_department" value="{{ old('nama_department',$department->nama_department) }}" required autocomplete="nama_department" autofocus>

                                @error('nama_department')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>


                        <div class="form-group row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Update') }}
                                </button>
                                <a href="{{ route('department.index') }}">
                                <button type="button" class="btn btn-danger">
                                    {{ __('Cancel') }}
                                </button>
                                </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    
@endsection

resources/views/pages/department/index.blade.php
@extends('layouts.app')

@section('title', 'Department')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Department') }}</div>

                <div class="card-body">
                    <div class="form-group row mb-4">
                        <div class="col-md-6">
                            <a href="{{ route('department.create') }}">
                            <button type="button" class="btn btn-primary">
                                {{ __('Input Data') }}
                            </button>
                            </a>
                        </div>
                    </div>

                    <table id="department" class="table table-striped table-bordered" style="width:100%">
                        <thead>
                            <tr>
                                <th>Nama Department</th>
                                <th>Kode Department</th>
                                <th>Aksi</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ( $listDepartment as $item)
                            <tr>
                                <td>{{ $item->nama_department }}</td>
                                <td>{{ $item->kode_department }}</td>
                                <td>
                                    <form method="POST" action="{{ route('department.destroy', \Crypt::encrypt($item->id)) }}">
                                    @csrf
                                    <input type="hidden" name="_method" value="DELETE">
                                    <div class="form-group row mb-0">
                                        <div class="col-md-12">
                                            <a href="{{ route('department.edit', \Crypt::encrypt($item->id)) }}">
                                            <button type="button" class="btn btn-primary">
                                                {{ __('Edit') }}
                                            </button>
                                            </a>
                                            <button type="submit" class="btn btn-danger" onclick="return confirm('anda yakin mau delete?')">
                                                {{ __('Delete') }}
                                            </button>
                                        </div>
                                    </div>
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        <tfoot>
                            <tr>
                                <th>Nama Department</th>
                                <th>Kode Department</th>
                                <th>Aksi</th>
                            </tr>
                        </tfoot>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    <script src="{{ URL::asset('js/department.js') }}"></script>
@endsection